%
%
%   Verification of the channel
%
%

clear

fdmT=1/2^5;
NN=2^10;

path1=Rayleigh_fading(fdmT, NN);
path2=Rayleigh_fading(fdmT, NN);

norm(path1).^2/length(path1)
norm(path2).^2/length(path2)


% Visual Test
subplot(2,1,1), plot(real(path1),'-y');hold on; plot(real(path2), '-r');hold off;
subplot(2,1,2), plot(imag(path1),'-y');hold on; plot(imag(path2), '-r');hold off;
'paused'
pause

clf
semilogy(abs(path1),'-y');hold on;plot(abs(path2),'-r');hold off;
'paused'
pause

norm(path1).^2/length(path1)
norm(path2).^2/length(path2)

% autocorrelation
xcorr1=xcorr(path1,'coeff');Lth=length(path1);
sample=xcorr1(Lth-200:Lth+200);
clf
subplot(2,1,1), plot(real(xcorr1(Lth-200:Lth+200)));grid on;
subplot(2,1,2), plot(imag(xcorr1(Lth-200:Lth+200)));grid on;

'paused'
pause

Lth=length(path1);
MaxL=1000; % num of symbols.
TimeUnit=2*pi*fdmT;
besselfunc=besselj(0,(0:TimeUnit:TimeUnit*MaxL)');
Corrf=xcorr(path1);Corrf=Corrf/Corrf(Lth);
clf
plot(real(Corrf(Lth:Lth+MaxL)),'--');hold on;
plot(besselfunc)
plot(imag(Corrf(Lth:Lth+MaxL)),'-.');hold off;
title('Time correlation function of a tap over time difference');
xlabel('symbol periods');
ylabel('Correlation value');
grid on;

'paused'
pause


NfdmT=1/fdmT;
%faxis=1:
Spd=abs(fft(Corrf,2*NN)).^2;Lspd=length(Spd);
%SampleSpectrum=[Spd(1:NfdmT) Spd(length(Spd)-NfdmT: length(Spd))

subplot(2,1,1),semilogy(Spd(1:2*NfdmT));
subplot(2,1,2),semilogy(Spd(length(Spd)-2*NfdmT:length(Spd)));
